NetBSD/distrib/common/cgdroot.rc

89 lines
2.5 KiB
Plaintext

# $NetBSD: cgdroot.rc,v 1.5 2019/11/22 00:27:30 alnsn Exp $
#
# Copyright (c) 2013 Pierre Pronchery <khorben@defora.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
PATH=/sbin:/usr/sbin:/bin:/usr/bin
export PATH
TERM=wsvt25
export TERM
HOME=/
export HOME
BLOCKSIZE=1k
export BLOCKSIZE
EDITOR=ed
export EDITOR
umask 022
# Mount /etc/cgd.
etc_cgd_mount=
for dev in NAME=cgd.conf /dev/wd0a /dev/ld0a ; do
if mount -o ro $dev /etc/cgd 2>/dev/null ; then
etc_cgd_mount=$dev
break
fi
done
if [ -z "${etc_cgd_mount}" ]; then
echo "Could not mount the boot partition" 1>&2
exit 2
fi
# Configure cgd device(s).
/sbin/wsconsctl -d -w splash.enable=0 > /dev/null 2>&1
cgdconfig -C
if [ $? -ne 0 ]; then
echo "Could not decrypt the encrypted volume" 1>&2
umount /etc/cgd
exit 2
fi
# Select candidates for a root mount.
root_mounts=
if [ -z "${etc_cgd_mount##NAME=*}" ]; then
root_mounts="NAME=cgdroot /dev/cgd0a"
else
root_mounts=/dev/cgd0a
fi
# Mount the root filesystem.
mounted=
for dev in ${root_mounts} ; do
if mount -o ro $dev /altroot 2>/dev/null ; then
mounted=$dev
break
fi
done
if [ -z "$mounted" ]; then
echo "Could not mount the root partition" 1>&2
cgdconfig -U
umount /etc/cgd
exit 2
fi
# Boot into /altroot.
umount /etc/cgd
/sbin/wsconsctl -d -w splash.enable=1 > /dev/null 2>&1
sysctl -w init.root=/altroot